

[Setting name="Target Season"]
string selectedSeasonId = "Current";
Season@ selectedSeason = null;


class Season {
    string name;
    uint season;
    uint year;
    Season(const string &in name, uint season, uint year) {
        this.name = name;
        this.season = season;
        this.year = year;
    }
    string getDisplayName() {
        if (this.name == 'Current') {
            return 'Current (' + getSeasonName(current_season, current_year) + ')';
        }
        return getSeasonName(this.season, this.year);
    }
    uint getSeason() {
        if (this.name == 'Current') {
            return current_season;
        }
        return this.season;
    }
    uint getYear() {
        if (this.name == 'Current') {
            return current_year;
        }
        return this.year;
    }

    int opCmp (Season@ b) { // 1 is this lower, -1 is this higher
        if (this.name == 'Current') {
            return -1;
        } else if (b.name == 'Current') {
            return 1;
        }
        if (this.year > b.year) {
            return -1;
        } if (this.year < b.year) {
            return 1;
        }
        if (this.season > b.season) {
            return -1;
        } if (this.season < b.season) {
            return 1;
        }
        return this.name.opCmp(b.name);
    }
    bool opEquals (Season@ b) {
        return this.season == b.season && this.year == b.year;
    }
}


array<Season@> seasons = {};

void SetSeasonOptions() {
    seasons.InsertLast(Season('Current', 0, 0));
    seasons.InsertLast(Season('Training', current_season - 2, current_year));
    // seasons.InsertLast(Season('Royal', 8, 2021)); // plugin doesn't detect records on royal yet
    seasons.InsertLast(Season('Snow Discovery', 0, 2024));
    seasons.InsertLast(Season('Rally Discovery', 4, 2024));
    seasons.InsertLast(Season('Desert Discovery', 8, 2024));
    seasons.InsertLast(Season('Stunt Discovery', 12, 2024));
    seasons.InsertLast(Season('Platform Discovery', 0, 2025));
    seasons.InsertLast(Season('Weekly Shorts', 2, 2025));
    uint season = 7;
    uint year = 2020;
    while (year < current_year || (year == current_year && season <= current_season)) {
        switch (season) {
            case 3: seasons.InsertLast(Season('Winter ' + year, season, year)); break;
            case 7: seasons.InsertLast(Season('Spring ' + year, season, year)); break;
            case 11: seasons.InsertLast(Season('Summer ' + year, season, year)); break;
            case 15: seasons.InsertLast(Season('Fall ' + year, season, year)); break;
        }
        if (season == 15) {
            season = 3;
            year += 1;
        } else {
            season += 4;
        }
    }
    seasons.SortAsc();
}

void SetSelectedSeason() {
    @selectedSeason = null;
    for (uint i = 0; i < seasons.Length; i++) {
        if (seasons[i].name == selectedSeasonId) {
            @selectedSeason = seasons[i];
            break;
        }
    }
}
